unit StudentU;
// 'n Oplossing vir Vraagn2.1 - klaseenheid

interface

type
   TStudent = class(TObject)
     private
       fNaam                 : string;
       fRegKode              : string;
       fVervalDatum          : string;
       fSessiesVoltooi       : integer;

       function bepaalVervalDatum(sDatum : string) : string;

     public
        constructor Create(Naam, RegKode, RegDatum: string);
        procedure setSessiesVoltooi(iSessies : integer);
        procedure vermeerderSessiesVoltooi;
        function evalueerVordering(iMaks : integer) : string;
        function toString: string;
        function GetNaam : string;
        function GetKode : string;
     end;

implementation

uses SysUtils, Math;
{ TStudent }

//======   Vraag 2.1.1  ===================================

function TStudent.BepaalVervalDatum(sDatum: string): string;
var
  iJaar : integer;

begin
   iJaar:= StrToInt(copy(sDatum,1,4)) + 2;
   result := IntToStr(iJaar) + copy(sDatum,5);
end;

//======   Vraag 2.1.2  ===================================

constructor TStudent.Create(Naam, RegKode, RegDatum: string);
begin
  fNaam        := Naam;
  fRegKode     := RegKode;
  fVervalDatum := bepaalVervalDatum(RegDatum);
  fSessiesVoltooi := 0;
end;


//======   Vraag 2.1.3  ===================================//

procedure TStudent.setSessiesVoltooi(iSessies : integer);
begin
  fSessiesVoltooi := iSessies;
end;

//======   Vraag 2.1.4  ===================================
procedure TStudent.VermeerderSessiesVoltooi;
begin
   Inc(fSessiesVoltooi, 1);
end;

//======   Vraag 2.1.5  ===================================
function TStudent.evalueerVordering(iMaks: integer): string;
var
  iVordering : integer;
begin
   iVordering := Trunc((fSessiesVoltooi / iMaks) * 100);
   if iVordering >= 75 then
     Result := fNaam + ' kwalifiseer as ''n instrukteur'
   else
     Result := 'Vordering: ' + IntToStr(iVordering) + '% voltooi';
end;

//======   Vraag 2.1.6  ===================================
function TStudent.toString: string;
begin
   Result := fNaam + ' [' + fRegKode + '] ' + #13 +
             'Vervaldatum: ' + fVervalDatum + #13 +
             'Voltooide sessies: ' + IntToStr(fSessiesVoltooi);
end;


//======  Metodes wat gegee is ===============================

function TStudent.GetNaam: string;
begin
  Result := fNaam;
end;

function TStudent.GetKode: string;
begin
  Result := fRegKode;
end;

//================================================================

end.
