unit Vraag3U;

// A solution for question 3.

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfrmVraag3 = class(TForm)
    pnlClose: TPanel;
    bmbClose: TBitBtn;
    pnlInput: TPanel;
    grpToevoer: TGroupBox;
    lblWerkswinkelBoodskap: TLabel;
    lblOnderwerp: TLabel;
    lblDag: TLabel;
    cboOnderwerp: TComboBox;
    lblOutput: TLabel;
    lblKomponente: TLabel;
    redVertoon: TRichEdit;
    btnVertoon: TButton;
    btnBespreking: TButton;
    btnKanselleerWerkswinkel: TButton;
    btnWater: TButton;
    lstDag: TListBox;
    lblSelekteerDag: TLabel;
    procedure btnVertoonClick(Sender: TObject);
    procedure btnBesprekingClick(Sender: TObject);
    procedure vertoon;
    procedure btnKanselleerWerkswinkelClick(Sender: TObject);
    procedure btnWaterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraag3: TfrmVraag3;

implementation

{$R *.dfm}
{$R+}

CONST
  Maksry: Integer = 6;
  MaksKol: Integer = 4;

var
  arrWerkswinkels: array [1 .. 6] of string = (
    'Aerobies',
    'Liggaamsbou',
    'Kardio',
    'Dans',
    'Energieaanvullings',
    'Eerstehulp'
  );

  getalWerkswinkels: Integer = 6;

  arrBespreking: array [1 .. 6, 1 .. 4] of integer = ((11, 14, 5, 14),
    (15, 5, 20, 4), (10, 14, 16, 20), (20, 20, 20, 20), (16, 7, 10, 7),
    (10, 18, 13, 11));

procedure TfrmVraag3.btnBesprekingClick(Sender: TObject);
var
  sWerkswinkel, sBoodskap: string;
  i, iDag, iWerkwinkel: integer;
begin
  sWerkswinkel := cboOnderwerp.Text;
  iWerkwinkel := 0;
  for i := 1 to getalWerkswinkels do
    if sWerkswinkel = arrWerkswinkels[i] then
      iWerkwinkel := i;
  if iWerkwinkel > 0 then
  begin
    iDag := lstDag.ItemIndex + 1;
    if arrBespreking[iWerkwinkel, iDag] < 20 then
    begin
      Inc(arrBespreking[iWerkwinkel, iDag]);
      sBoodskap := sWerkswinkel + ' op dag ' + IntToStr(iDag) + ' is suksesvol bespreek';

    end
    else
      sBoodskap := sWerkswinkel + ' op dag ' + IntToStr(iDag)   + ' is volledig bespreek';

  end
  else
    sBoodskap := 'Werkswinkel: ' + sWerkswinkel + ' Nie beskikbaar';

  MessageDlg(sBoodskap, mtInformation, [mbOk], 0);
  vertoon;
end;

procedure TfrmVraag3.btnVertoonClick(Sender: TObject);

begin
  vertoon;
end;

procedure TfrmVraag3.btnKanselleerWerkswinkelClick(Sender: TObject);
var
  i, w, d, iVerwyderReel: Integer;
  sWerkswinkel: String;

begin
  iVerwyderReel := 0;
  sWerkswinkel := cboOnderwerp.Text;
  for i := 1 to getalWerkswinkels do
    if sWerkswinkel = arrWerkswinkels[i] then
    begin
      iVerwyderReel := i;

      for w := iVerwyderReel to getalWerkswinkels - 1 do
        arrWerkswinkels[w] := arrWerkswinkels[w + 1];

      for d := 1 to 4 do
        for w := iVerwyderReel to getalWerkswinkels - 1 do
          arrBespreking[w, d] := arrBespreking[w + 1, d];

      Dec(getalWerkswinkels);
    end;
  vertoon;
end;

procedure TfrmVraag3.btnWaterClick(Sender: TObject);
var
  w, d, iTotaal, iDagTot: Integer;
  sReel: String;

begin
  redVertoon.Lines.Add('Bottels water wat benodig word');
  iTotaal := 0;
  for d := 1 to 4 do
  begin
    iDagTot := 0;
    for w := 1 to getalWerkswinkels do
      iDagTot := iDagTot + arrBespreking[w, d];
    redVertoon.Lines.Add('Dag ' + IntToStr(d) + #9 + IntToStr(iDagTot));
    iTotaal := iTotaal + iDagTot;
  end;
  redVertoon.Lines.Add(#10 + 'Totaal: ' + #9 + IntToStr(iTotaal));
  redVertoon.Lines.Add('Kaste water wat benodig word:' + #9 + IntToStr
      ((iTotaal + 12) div 24));

end;


procedure TfrmVraag3.FormCreate(Sender: TObject);
begin
  redVertoon.Clear;
  redVertoon.Paragraph.TabCount := 4;
  redVertoon.Paragraph.Tab[0] := 160;
  redVertoon.Paragraph.Tab[1] := 200;
  redVertoon.Paragraph.Tab[2] := 250;
  redVertoon.Paragraph.Tab[3] := 300;
end;

procedure TfrmVraag3.vertoon;

var
  w, d: Integer;
  sReel: String;

begin
  redVertoon.Clear;
  redVertoon.Paragraph.TabCount := 4;
  redVertoon.Paragraph.Tab[0] := 160;
  redVertoon.Paragraph.Tab[1] := 200;
  redVertoon.Paragraph.Tab[2] := 250;
  redVertoon.Paragraph.Tab[3] := 300;
  redVertoon.Lines.Add
    ('Werkswinkel' + #9 + 'Dag 1' + #9 + 'Dag 2' + #9 + 'Dag 3' + #9 + 'Dag 4' + #10);
  for w := 1 to getalWerkswinkels do
  begin
    sReel := arrWerkswinkels[w];
    for d := 1 to 4 do
      sReel := sReel + #9 + IntToStr(arrBespreking[w, d]);
    redVertoon.Lines.Add(sReel);
  end;
end;



end.
